#include <stdio.h>
#include <string.h>

#include "crypt.h"

void printhex(const char *msg, const char *src, size_t src_len)
{
	int i;
	printf("%s", msg);
	for (i = 0; i < src_len; i++)
		printf("%.2x ", (unsigned char) src[i]);
	printf("\n");
}

int main(int argc, char **argv)
{
	const char key[] = "super clée";
	const char msg[] = "message à chiffrer";
	char cryptogram[100] = { 0 };
	char msg_decrypted[100];
	int ret;

	printhex("Le message original est  : ", msg, strlen(msg));

	crypt(msg, strlen(msg) + 1, cryptogram, key, strlen(key));
	printhex("Le cryptogramme est      : ", cryptogram, strlen(msg));

	decrypt(cryptogram, strlen(msg) + 1, msg_decrypted, key, strlen(key));
	printhex("Le message déchiffré est : ", msg_decrypted, strlen(msg));

	ret = strncmp(msg, msg_decrypted, strlen(msg)) == 0;
	if (ret)
		printf("Positive match: Bravo :)\n");
	else
		printf("Procédure de chiffrement invalide: Try again :(\n");

	return 0;
}
